package com.njcn.csdevice.api.fallback;

import com.njcn.common.pojo.enums.response.CommonResponseEnum;
import com.njcn.common.pojo.exception.BusinessException;
import com.njcn.common.pojo.response.HttpResult;
import com.njcn.csdevice.api.DevCapacityFeignClient;
import com.njcn.csdevice.pojo.po.CsDevCapacityPO;
import feign.hystrix.FallbackFactory;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Component;

import java.util.List;

/**
 * @author xy
 */
@Slf4j
@Component
public class DevCapacityClientFallbackFactory implements FallbackFactory<DevCapacityFeignClient> {
    @Override
    public DevCapacityFeignClient create(Throwable cause) {
        //判断抛出异常是否为解码器抛出的业务异常
        Enum<?> exceptionEnum = CommonResponseEnum.SERVICE_FALLBACK;
        if (cause.getCause() instanceof BusinessException) {
            BusinessException businessException = (BusinessException) cause.getCause();
        }
        Enum<?> finalExceptionEnum = exceptionEnum;
        return new DevCapacityFeignClient() {

            @Override
            public HttpResult<List<String>> addList(List<CsDevCapacityPO> list) {
                log.error("{}异常，降级处理，异常为：{}","批量新增设备模块容量",cause.toString());
                throw new BusinessException(finalExceptionEnum);
            }

            @Override
            public HttpResult<Double> getDevCapacity(String id) {
                log.error("{}异常，降级处理，异常为：{}","获取设备模块容量",cause.toString());
                throw new BusinessException(finalExceptionEnum);
            }

        };
    }
}
